;     ķ
;      Gouraud texture polyfiller 
;       (C) Dave / ByTeam 1996.   
;     ͼ
;            Xtended 4 phong
;
; IN:  ds - code_seg
;      es - screen_seg  (320x200)
;      fs - texture_seg (256x256x8)
;     (gs - zbuffer_seg)

.386
;
; c000000l makrok
;
_add macro a,b
add a,88888888h
org $-4
b dd ?
endm
;
_mov macro a,b
mov a,88888888h
org $-4
b dd ?
endm
;
_cmp macro a,b
cmp a,88888888h
org $-4
b dd ?
endm

divmacro macro
shl eax,16
cdq
idiv ecx
endm

divmacro2:; macro
;local nm1_gt
;local nm2_gt

cmp ax,192
jl nm1_gt
neg ax
add ax,256
nm1_gt:

cmp ax,-192
jg nm2_gt
add ax,256
nm2_gt:

shl eax,16
cdq
idiv ecx
retn
;endm
;
; polyfiller...
;
assume ds:code
gtfiller:

xor bx,bx                       ; offset of 1st point
mov si,4                        ; offset of 2nd point
mov di,8                        ; offset of 3rd point

mov ax,pointbuf[00][02]
movzx ecx,w pointbuf[04][02]
mov dx,pointbuf[08][02]

cmp ax,cx
jle nosort1_gt
xchg ax,cx
xchg bx,si
nosort1_gt:
cmp ax,dx
jle nosort2_gt
xchg ax,dx
xchg bx,di
nosort2_gt:
cmp cx,dx
jle nosort3_gt
xchg cx,dx
xchg si,di
nosort3_gt:

;
; Sorted now - points   -  EAX / ECX / EDX
;            - offsets  -  EBX / ESI / EDI
;


;
; Quotient 1 -> 2  (right 1)
;

sub cx,ax
inc cx

mov ax,pointbuf[si]
sub ax,pointbuf[bx]
divmacro
mov d [Xadd12_gt],eax

mov ax,w colorbuf[si]
sub ax,w colorbuf[bx]
divmacro
mov d [Cadd12_gt],eax

mov ax,w zbuf[si]
sub ax,w zbuf[bx]
cwd
idiv cx
mov w [Zadd12_gt],ax

mov ax,w textibuf[si]
sub ax,w textibuf[bx]
call divmacro2
;divmacro
mov d [Uadd12_gt],eax

mov ax,w textibuf[si][02]
sub ax,w textibuf[bx][02]
call divmacro2
;divmacro
mov d [Vadd12_gt],eax

;
; Quotient 2 -> 3  (right 2)
;

mov cx,w pointbuf[di][02]
sub cx,w pointbuf[si][02]
inc cx

mov ax,w pointbuf[di]
sub ax,w pointbuf[si]
divmacro
mov d poly_temp[60],eax

mov ax,w colorbuf[di]
sub ax,w colorbuf[si]
divmacro
mov d poly_temp[64],eax

mov ax,w zbuf[di]
sub ax,w zbuf[si]
cwd
idiv cx
mov w poly_temp[56],ax

mov ax,w textibuf[di]
sub ax,w textibuf[si]
call divmacro2
;divmacro
mov d poly_temp[68],eax

mov ax,w textibuf[di][02]
sub ax,w textibuf[si][02]
call divmacro2
;divmacro
mov d poly_temp[72],eax

;
; Quotient 1 -> 3  (left 1/2)
;

movzx ecx,w pointbuf[di][02]
sub cx,w pointbuf[bx][02]
inc cx

mov ax,w pointbuf[di]
sub ax,w pointbuf[bx]
divmacro
mov d [Xadd13_gt],eax

mov ax,w colorbuf[di]
sub ax,w colorbuf[bx]
divmacro
mov d [Cadd13_gt],eax

mov ax,w zbuf[di]
sub ax,w zbuf[bx]
cwd
idiv cx
mov w [Zadd13_gt],ax

mov ax,w textibuf[di]
sub ax,w textibuf[bx]
call divmacro2
;divmacro
mov d [Uadd13_gt],eax

mov ax,w textibuf[di][02]
sub ax,w textibuf[bx][02]
call divmacro2
;divmacro
mov d [Vadd13_gt],eax


;
; Initialization..
;
; ebx, esi, edi

movsx eax,w pointbuf[si][02]        ;Y2
lea eax,[eax*4+eax]
sal eax,6                       ;Y2 * 320
mov change_gt,eax

mov ax,w colorbuf[bx]
;shl eax,16
mov w poly_temp[24+2],ax
mov w poly_temp[28+2],ax
;
mov ax,w textibuf[bx]
;shl eax,16
mov w poly_temp[32+2],ax
mov w poly_temp[36+2],ax
mov ax,w textibuf[bx][02]
;shl eax,16
mov w poly_temp[40+2],ax
mov w poly_temp[44+2],ax

mov si,w pointbuf[bx]
sal esi,16                      ;esiben a bal oldal
mov edi,esi                     ;ediben a jobb oldal

movsx eax,w pointbuf[bx][02]
lea eax,[eax*4+eax]
sal eax,6                       ;Y1 * 320
mov poly_temp[48],eax           ;store it..


;xor ax,ax                     ;IS CHANGED?? signal
mov ax,o Zadd12_gt
mov ebp,Xadd13_gt
cmp ebp,Xadd12_gt
jle lrok_gt
xchg ebp,Xadd12_gt
mov Xadd13_gt,ebp
mov ebp,Cadd13_gt
xchg ebp,Cadd12_gt
mov Cadd13_gt,ebp
mov bp,Zadd13_gt
xchg bp,Zadd12_gt
mov Zadd13_gt,bp
mov ebp,Uadd13_gt
xchg ebp,Uadd12_gt
mov Uadd13_gt,ebp
mov ebp,Vadd13_gt
xchg ebp,Vadd12_gt
mov Vadd13_gt,ebp
;inc ax
sub ax,o Zadd12_gt - o Zadd13_gt
lrok_gt:
mov w poly_temp[52],ax                       ;store signal..

mov bp,w zbuf[bx]
;shl ebp,16
mov dx,bp

;mov w poly_temp[12],1

jmp mainloop                    ; fresh prefetch buffer..

;
; Yeah, the MAIN LOOP...
;

mainloop:

 add bp,1234h
 org $-2
 Zadd13_gt dw ?
_add edi,Xadd13_gt              ;U P D A T E !
_add poly_temp[24],Cadd13_gt
_add poly_temp[32],Uadd13_gt
_add poly_temp[40],Vadd13_gt

 add dx,1234h
 org $-2
 Zadd12_gt dw ?
_add esi,Xadd12_gt
_add poly_temp[28],Cadd12_gt
_add poly_temp[36],Uadd12_gt    ;texturakoordinatak bal/jobb
_add poly_temp[44],Vadd12_gt    ;EZEKNEK A SORRENDJE FONTOS!

_cmp poly_temp[48],change_gt
jz dochange_gt
nochange_gt:

;
; inner loop initialization..
;

; CLIP UP/DOWN
;cmp poly_temp[48],0
;jle nohorizline_gt
cmp poly_temp[48],320*200
jg exit_gt
jae nohorizline_gt

push cx esi edi bp dx

;shr ebp,16
;shr edx,16
;
sar esi,16
sar edi,16
;mov ebx,esi
jge more1_gt
xor di,di             ;ha veletlenul esi < 0 ..
more1_gt:

cmp si,319
jle more2_gt
mov si,319
more2_gt:

mov cx,si
sub cx,di
js nohorizline_gt2
inc cx

add di,w poly_temp[48]   ;edi-ben a sor kezdetenek offsetje a screenen..
mov si,di
mov ax,zbuffer_seg
add si,si
jnc zok1_gt
add ax,4096
zok1_gt:
mov gs,ax

;
; Horizontal quotiens calculation
;
;cmp w poly_temp[12],1
;jnz was_hcalc_gt
mov ax,dx                  ;Z - quotient
sub ax,bp
cwd
idiv cx
mov w poly_temp[12],ax

movsx ecx,cx
mov eax,poly_temp[28]        ;C - quotient
sub eax,poly_temp[24]
cdq
idiv ecx
shl eax,8
xor ax,ax
mov d poly_temp[4],eax

mov eax,poly_temp[36]        ;U - quotient
sub eax,poly_temp[32]
cdq
idiv ecx
sar eax,8
mov w poly_temp[8],ax

mov eax,poly_temp[44]        ;V - quotient
sub eax,poly_temp[40]
cdq
idiv ecx
sar eax,8
mov w poly_temp[10],ax

;was_hcalc_gt:
; eax:             |     data..
; ebx:             |   V   |   U
; ecx: color value |    counter
; edx:   V value   |    U value
; esi:             z-buffer offset
; edi:              screen offset
; ebp:                  Z value


mov edx,poly_temp[40-1]
mov dx,w poly_temp[32][1]
;
push cx
mov ecx,d poly_temp[23]
pop cx

; Ŀ
;  INNERLOOP 
; 
innerloop_gt:
cmp bp,gs:[si]
ja il_noput_gt
mov gs:[si],bp

shld ebx,edx,16
mov bl,dh
shld eax,ecx,8

mov ah,fs:[bx]

and ah,not 31
cmp cs:[which_shade],0
jz ok1_gt
  mov ah,fs:[bx]
  shr ah,1
  shr al,1

  ;sub ah,10
  ;jns ok2_gt
  ;  xor ah,ah
  ;ok2_gt:
  ;
  add al,0
  org $-1
  which_shade db ?
ok1_gt:

add al,ah
mov es:[di],al
;stosb
;dec di

il_noput_gt:
add bp,w poly_temp[12]
add edx,poly_temp[8]
add ecx,poly_temp[4]
inc di
inc si
inc si
loop innerloop_gt


nohorizline_gt2:
pop dx bp edi esi cx

nohorizline_gt:
add poly_temp[48],320           ;noveljuk a sort is

dec cx
jnz mainloop

exit_gt:
retn


;
; Quotients change for mainloop..
;

comment @
dochange_gt:
push cx edx ebp
mov eax,poly_temp[56]
mov ebx,poly_temp[60]
mov cx,w poly_temp[64]
mov edx,poly_temp[68]
mov ebp,poly_temp[72]

cmp w poly_temp[52],0
jz change2_gt
mov Xadd13_gt,eax
mov Cadd13_gt,ebx
mov w Zadd13_gt,cx
mov Uadd13_gt,edx
mov Vadd13_gt,ebp
ch_exit_gt:
pop ebp edx cx
jmp nochange_gt

change2_gt:
mov Xadd12_gt,eax
mov Cadd12_gt,ebx
mov w Zadd12_gt,cx
mov Uadd12_gt,edx
mov Vadd12_gt,ebp
jmp ch_exit_gt
@

dochange_gt:
push si
mov si,o poly_temp[56]
mov bx,w poly_temp[52]

;mov ax,w poly_temp[64]
lodsd
mov [bx],ax
add bx,5
;
;mov eax,poly_temp[56]
lodsd
mov [bx],eax
add bx,9
;
;mov eax,poly_temp[60]
lodsd
mov [bx],eax
add bx,9
;
;mov eax,poly_temp[68]
lodsd
mov [bx],eax
add bx,9
;
;mov eax,poly_temp[72]
lodsd
mov [bx],eax

pop si
jmp nochange_gt
