; DESCRIPTORTABLES:
;-------------------
;offset  description
;  00      pointnumber
;  02      facenumber
;  04      pointofs
;  06      faceofs
;  08      normalofs
;  10      texticooofs
;  12      xadd
;  14      yadd
;  16      zadd
;  18      alfa
;  20      beta
;  22      gamma
;
; megj.: egy object pontjai egymas mellett vannak a memoriaban
;        a konnyebb masolas es rotalas vegett.

screendist  = 800
persp_sar_x = 2
persp_sar_y = 2
clip_normal = 80

; Ŀ
;  R E N D E R I N G 
; 

render_cz:

push ax
push zbuffer_seg
pop es
xor di,di
mov cx,16384
push cx
xor eax,eax
dec eax
rep stosd
pop cx
push zbuffer_seg+4096
pop es
rep stosd

; most addoljuk az objket..
push object_seg
pop es
push es
pop ds

; 1)
mov di,o descriptortables[12]
mov ax,-1000
stosw
;....
mov ax,dx
neg ax
shl ax,8
stosw

mov ax,5000
stosw
mov ax,768
stosw
add di,4+12+2

; 2)
mov ax,-1500
stosw
;...
mov ax,bx
add ax,4000/64
sal ax,6
;add ax,4000
stosw

add w [di],15
add w [di][2],10
add w [di][4],9
add di,6+12+2

; 3)
mov ax,1500
stosw
;...
mov ax,6000/64
sub ax,bx
sal ax,6
stosw

add w [di],10
add w [di][2],8
add w [di][4],6
add di,6+12

; 4)
;...
mov ax,cs:[timercounter]
sub ax,(180+230+180+600)+ 700 + 250
shl ax,4
stosw
;...
stosw

mov ax,6000
stosw
add w [di],15
add w [di][2],12
add w [di][4],10
add di,6+12+4

; 5)
;...
mov ax,bx
add ax,5000/64
sal ax,6
;add ax,5000
stosw

add w [di],10
add w [di][2],8
add w [di][4],6
add di,6+12+4

; 6)
;...
stosw

add w [di],15
add w [di][2],10
add w [di][4],9
add di,6+12+4

; light..
sal bx,7
sal dx,7
neg bx
neg dx
mov [lightx],bx
mov [lighty],dx
mov [lightz],12000

pop ax

; ---------------------------------------------------------------------------

render:
push object_seg
pop ds
push ds
pop es

mov cs:[which_shade],al
mov dl,ah

mov di,o faces2                 ; where store faces
xor bp,bp                       ; pointnum eddig
mov [facenum],0                 ; facenum init
;mov dl,[which_objects_show]     ; which will be shown
mov bx,o descriptortables       ; tables
mov cx,objectnum                ; maxobjnum
fc_cik1_rr:
push cx
  shr dl,1
  jnc fc_noputobj_rr            ; ha nem kell kirakni..
    ; atmasoljuk a facekat..
    mov cx,[bx][02]
    add [facenum],cx
    imul cx,3                   ; facenum*3
    mov si,[bx][06]          ; faceofs
    fc_cik2_rr:
      lodsw
      add ax,bp
      stosw
    loop fc_cik2_rr
    ; rotaljuk a pontokat
    lea si,[bx+18]
    call initrotate12
    mov eax,d [bx][12]
    mov d [d_xadd],eax
    mov ax,w [bx][16]
    mov w [d_zadd],ax
    push di
    imul di,bp,6
    push di
    add di,o points2            ; rotated points
    mov si,[bx][04]
    mov cx,[bx]
    call rotate12
    xor eax,eax
    mov d [d_xadd],eax
    mov [d_zadd],ax
    mov si,[bx][08]
    pop di
    add di,o normals2           ; rotated normals
    call rotate12
    ; atmasoljuk a texticookat
    ;mov si,o texticoos1
    mov si,[bx][10]
    imul di,bp,2
    add di,o texticoos2
    add bp,cx
    rep movsw
    pop di
  fc_noputobj_rr:
  add bx,24                     ; next object..
pop cx
loop fc_cik1_rr

mov [pointnum],bp


; perspektivikusan lekepezzuk
mov si,o points2
mov di,o points3
mov bx,screendist
mov cx,[pointnum]
pl_cik1_rr:
  mov bp,[si][04]               ; z
  lodsw
  imul bx                       ; x*z0
  idiv bp
  sar ax,persp_sar_x
  add ax,160
  stosw                         ; scale( x * z0 / z ) + 160
  lodsw
  imul bx
  idiv bp
  sar ax,persp_sar_y
  add ax,100
  stosw
  lodsw
loop pl_cik1_rr

; szinek kiszamitasa DOT PRODUCT-tal
mov cx,[pointnum]
mov si,o points2
mov di,o colors
cc_cik1_rr:
  mov ax,[lightx]
  sub ax,[si]
  mov [x5],ax
  mov ax,[lighty]
  sub ax,[si][02]
  mov [y5],ax
  mov ax,[lightz]
  sub ax,[si][04]
  mov [z5],ax
  pusha
  mov si,o x5
  mov di,o x6
  call normalize_vector
  popa
  ; most yon a dotproduct
  mov ax,[x6]
  cwd
  imul w [si+o normals2-o points2]
  mov bx,ax
  mov ax,[y6]
  cwd
  imul w [si+o normals2-o points2][02]
  add bx,ax
  mov ax,[z6]
  cwd
  imul w [si+o normals2-o points2][04]
  add ax,bx
  sar ax,10
  add al,15
  jns cc_ok1_rr
  xor al,al
  cc_ok1_rr:
  inc al
  stosb
  add si,6
loop cc_cik1_rr

; PHONG stuff
cmp cs:[which_shade],0
jz nophong_rr
mov di,o texticoos2
mov si,o normals2
mov cx,[pointnum]
ph_cik1_rr:
push cx
  lodsw
  mov cs:[x2],ax
  lodsw
  mov cs:[y2],ax
  lodsw
  mov cs:[z2],ax
  push ds cs
  pop ds
    call convert2polaar_2
  pop ds
  stosb
  mov al,cl
  stosb
pop cx
loop ph_cik1_rr
nophong_rr:

; most pedig kirakjuk a screenre
mov si,o faces2
mov cx,[facenum]
fo_cik1_rr:
  mov bp,2*4
  fo_cik2_rr:
    lodsw
    imul bx,ax,6
;    cmp w normals2[bx][4],clip_normal
;    jl fo_noclipnormal_rr
;      shr bp,1
;      add si,bp
;      jmp fo_clipnormal_rr
;    fo_noclipnormal_rr:
    ;
    mov dx,points2[bx][4]
    mov w cs:zbuf[bp],dx
    ;
    mov bx,ax
    movzx dx,b colors[bx]
    ;mov dx,16
    mov w cs:colorbuf[bp],dx     ; dh=0
    ;
    add bx,bx
    mov dl,texticoos2[bx]        ; textura koordinatak
    mov w cs:textibuf[bp],dx
    mov dl,texticoos2[bx][01]
    mov w cs:textibuf[bp][02],dx
    ;
    add bx,bx
    mov edx,d points3[bx]         ; lekepezett pontok
    mov d cs:pointbuf[bp],edx
  sub bp,4
  jns fo_cik2_rr
  push ds
  mov ax,texture_seg
  cmp cs:[which_shade],0
  jz ok3_rr
    mov ax,shadetable_seg
  ok3_rr:
  push ax screen_seg cs
  pop ds es fs
  pusha
    call gtfiller
  popa
  pop ds
  fo_clipnormal_rr:
loop fo_cik1_rr

retn

